/**
 * 
 */
package de.mcs.tools.sps;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.List;

import de.mcs.tools.sps.annotations.SPSOutputter;
import de.mcs.tools.sps.mnemonic.Mnemonic;

/**
 * @author w.klaas
 *
 */
@SPSOutputter(name = "HEXTXT")
public class HEXTextOutputter implements Outputter {

  /**
   * 
   */
  public HEXTextOutputter() {
    // TODO Auto-generated constructor stub
  }

  /* (non-Javadoc)
   * @see de.mcs.tools.sps.Outputter#output(java.util.List, java.io.OutputStream)
   */
  @Override
  public void output(List<Mnemonic> mnemonics, OutputStream output) {
    try (Writer writer = new BufferedWriter(new OutputStreamWriter(output))) {
      int address = 0;
      for (Mnemonic mnemonic : mnemonics) {
        writer.write(String.format("%02x", mnemonic.getByte()));
        address++;
        if ((address % 8) == 0) {
          writer.write("\r\n");
        } else {
          writer.write(" ");
        }
      }
    } catch (IOException e) {
      e.printStackTrace();
    } finally {
    }
  }

  @Override
  public String getDefaultExtension() {
    return ".txt";
  }

}
