/**
 * 
 */
package de.mcs.tools.sps;

import java.io.OutputStream;
import java.util.List;

import de.mcs.tools.IntelHex;
import de.mcs.tools.sps.annotations.SPSOutputter;
import de.mcs.tools.sps.mnemonic.Mnemonic;

/**
 * @author w.klaas
 *
 */
@SPSOutputter(name = "HEX")
public class IntelHEXOutputter implements Outputter {

  /**
   * 
   */
  public IntelHEXOutputter() {
    // TODO Auto-generated constructor stub
  }

  /* (non-Javadoc)
   * @see de.mcs.tools.sps.Outputter#output(java.util.List, java.io.OutputStream)
   */
  @Override
  public void output(List<Mnemonic> mnemonics, OutputStream output) {
    IntelHex intelHex = new IntelHex();
    byte[] data = new byte[mnemonics.size()];
    int i = 0;
    for (Mnemonic mnemonic : mnemonics) {
      data[i] = (byte) mnemonic.getByte();
      i++;
    }
    intelHex.writeHexStream(output, data);
  }

  @Override
  public String getDefaultExtension() {
    return ".hex";
  }

}
