/**
 * 
 */
package de.mcs.tools.sps.emulator;

/**
 * a single command data for the emulator
 * 
 * @author w.klaas
 *
 */
public interface SPSCommandData {

  /**
   * 
   * @return the command this data belongs to
   */
  SPSCommand getCommand();

  /**
   * @return the name of this command
   */
  String getName();

  /**
   * @return the short Mnemonic
   */
  String getMnemonic();

  /**
   * @return the byte code for this command and data
   */
  byte getCommandByte();

  /**
   * here the work should be done
   */
  EmulatorOutput doWork(EmulatorInput input, EmulatorInternals internals, EmulatorOutput output);

}
